if LibBNAddonMsg then return end
LibBNAddonMsg = {}
local LibBNAddonMsg = LibBNAddonMsg
do
	local a = CreateFrame("Frame")
	a:SetScript("OnEvent", function()
		LibBNAddonMsg.FriendsData = LibBNAddonMsg.FriendsData or {}
		for friendID=1, BNGetNumFriends() do
			local presenceID, givenName, surName = BNGetFriendInfo(friendID)
			LibBNAddonMsg.FriendsData[BNTokenCombineGivenAndSurname(givenName.." "..surName)] = {presence=presenceID, friendID=friendID}
		end
	end)
	a:RegisterEvent("BN_FRIEND_LIST_SIZE_CHANGED")
	a:RegisterEvent("BN_NEW_PRESENCE")
end
local registers = {}
local all_registers = {}
function LibBNAddonMsg:RegisterForPrefix(prefix, callback)
	registers[prefix] = registers[prefix] or {}
	tinsert(registers[prefix], callback)
end
function LibBNAddonMsg:RegisterForAll(callback)
	tinsert(all_registers,callback)
end
function LibBNAddonMsg:SendAddonMessage(prefix, msg, target)
	if not self.FriendsData then
		self.FriendsData = {}
		for friendID=1, BNGetNumFriends() do
			local presenceID, givenName, surName = BNGetFriendInfo(friendID)
			self.FriendsData[BNTokenCombineGivenAndSurname(givenName.." "..surName)] = {presence=presenceID, friendID=friendID}
		end
	end
	local presenceID = self.FriendsData[target] and self.FriendsData[target].presence or BNet_GetPresenceID(target)
	if not presenceID then
		error("Invalid target "..target.." specified in LibBNAddonMsg:SendAddonMessage(prefix, message, target)")
	end
	if (select(6,BNGetFriendInfo(self.FriendsData[target].friendID))) == "WoW" then
		BNSendWhisper(presenceID, "LBNAM\t"..prefix.."\t"..msg)
	end
end
function LibBNAddonMsg:NameToToken(nameString)
	local presenceID = BNet_GetPresenceID(nameString)
	if presenceID then
		for friendIndex = 1,BNGetNumFriends() do
			local friendPresenceID, givenName, surName, _, _, playedGame = BNGetFriendInfo(friendIndex)
			if (friendPresenceID == presenceID) and (playedGame == "WoW") then
				return (BNTokenCombineGivenAndSurname(givenName.." "..surName))
			end
		end
	end
end
function LibBNAddonMsg:RealmCharToToken(rcString)
	-- rc format is "Char-RealmName"
	for friendIndex = 1,BNGetNumFriends() do
		local presenceID, givenName, surName, _, _, game = BNGetFriendInfo(friendIndex)
		if game == "WoW" then
			local _, char, _, realm = BNGetToonInfo(presenceID)
			if (char.."-"..realm:gsub("%s","")) == rcString then
				return (BNTokenCombineGivenAndSurname(givenName.." "..surName))
			end
		end
	end
end
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", function(frame,event,msg, sender)
	local prefix, msg = string.match(msg, "LBNAM\t([^|]-)\t(.+)")
	if prefix then
		if registers[prefix] then
			for num, callback in pairs(registers[prefix]) do
				callback(msg, sender)
			end
		end
		for num, callback in pairs(all_registers) do
			callback(prefix, msg, sender)
		end
		return true
	else
		return false
	end
end)
--ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER_INFORM", print)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER_INFORM", function(frame,event,msg)
	if msg:find("LBNAM\t([^|]+)\t(.+)") then
		return true
	else
		return false
	end
end)